unit linux;

interface

const
  OEM2KOI8: array [0..31] of byte =
  (193,194,215,199,196,197,214,218,201,202,203,204,205,206,207,208,
   210,211,212,213,198,200,195,222,219,221,223,217,216,220,192,209
  );

procedure SaveToLinuxFile(FileName: string);

implementation

uses
  main, Dialogs;

function Win2Koi(s: string): string;
var
  i:integer;
  c:char;
begin
  for i:=1 to Length(s) do begin
    c := s[i];
    case c of
     #192..#223: c := Chr(OEM2KOI8[Ord(c)-192]+32);
     #224..#255: c := Chr(OEM2KOI8[Ord(c)-224]);
     #168: c := #179;
     #184: c := #163;
    end;
    s[i] := c;
  end;
  Result := s;
end;

procedure SaveToLinuxFile(FileName: string);
var
  f: File;
  i: integer;
  s: string;
begin
  try
    AssignFile(f, Filename); Rewrite(f,1);
    try
      with Form1.SourceMemo do
       for i := 0 to Lines.Count-1 do
      begin
        s := Win2Koi(Lines[i]) + #10;
        BlockWrite(f, s[1], Length(s));
      end;
    finally
      CloseFile(f);
    end;
  except
    MessageDlg('   ', mtError, [mbOk], 0);
  end;
end;

end.
