unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, vars, linux;

type
  TForm1 = class(TForm)
    SourceMemo: TMemo;
    ComboBox1: TComboBox;
    Label1: TLabel;
    ComboBox2: TComboBox;
    Label2: TLabel;
    ConvertBtn: TButton;
    LoadBtn: TButton;
    StatusBar1: TStatusBar;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    SaveBtn: TButton;
    procedure LoadBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ConvertBtnClick(Sender: TObject);
    procedure SaveBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ComboBox1Change(Sender: TObject);
    procedure SourceMemoKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SourceMemoClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  ComboBox1.ItemIndex := 2;
  ComboBox1Change(Sender);
  ComboBox2.ItemIndex := 0;
  Zone := TZone.Create;
  RoomList := TRoomList.Create;
  ObjList := TObjList.Create;
  MobList := TMobList.Create;
  ShopList := TShopList.Create;
  OpenDialog1.InitialDir := GetCurrentDir;
  SaveDialog1.InitialDir := GetCurrentDir;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Zone.Free;
  RoomList.Free;
  ObjList.Free;
  MobList.Free;
  ShopList.Free;
end;

procedure TForm1.LoadBtnClick(Sender: TObject);
begin
  if OpenDialog1.Execute then
   SourceMemo.Lines.LoadFromFile(OpenDialog1.FileName);
end;

procedure TForm1.SaveBtnClick(Sender: TObject);
begin
  if SaveDialog1.Execute then
   SourceMemo.Lines.SaveToFile(SaveDialog1.FileName);
end;

procedure TForm1.ConvertBtnClick(Sender: TObject);
var
  Code, i, j: integer;
begin
  case ComboBox2.ItemIndex of
   0: {Adamant}
   begin
     case ComboBox1.ItemIndex of
      0: Code := Zone.Convert;
      1: Code := RoomList.Convert;
      2: Code := ObjList.Convert;
      3: Code := MobList.Convert;
      4: Code := ShopList.Convert;
      else Code := 1;
     end;
     if Code = 0 then
     begin
      if SaveDialog1.Execute then
       case ComboBox1.ItemIndex of
        0: Zone.SaveToFile(SaveDialog1.FileName);
        1: RoomList.SaveToFile(SaveDialog1.FileName);
        2: ObjList.SaveToFile(SaveDialog1.FileName);
        3: MobList.SaveToFile(SaveDialog1.FileName);
        4: ShopList.SaveToFile(SaveDialog1.FileName);
        5: {TriggerList.SaveToFile(SaveDialog1.FileName)};
       end;
     end else
      with SourceMemo do
     begin
       j := 0;
       for i := 1 to Code do Inc(j, Length(Lines[i-1])+2);
       SelStart := j;
       SourceMemoClick(Sender);
       SourceMemo.SetFocus;
       SendMessage(SourceMemo.Handle, EM_SCROLLCARET, 0, 0);
     end;
   end; {Adamant}
   1: {Linux}
   begin
     if SaveDialog1.Execute then
      SaveToLinuxFile(SaveDialog1.FileName);
   end; {Linux}
  end; {ComboBox2}
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  OpenDialog1.Filter := Filter[ComboBox1.ItemIndex];
  OpenDialog1.DefaultExt := DefaultExt[ComboBox1.ItemIndex];
  SaveDialog1.Filter := Filter[ComboBox1.ItemIndex];
  SaveDialog1.DefaultExt := DefaultExt[ComboBox1.ItemIndex];
end;

procedure TForm1.SourceMemoKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  SourceMemoClick(Sender);
end;

procedure TForm1.SourceMemoClick(Sender: TObject);
var
  i, Row: integer;
begin
  Row := 0;
  i := 0;
  with SourceMemo do
   if Lines.Count > 0 then
    while i <= (SelStart - Length(Lines[Row]) - 2) do
  begin
    Inc(i, Length(Lines[Row]) + 2);
    Inc(Row);
  end;
  StatusBar1.SimpleText := Format('%d:  %d', [SourceMemo.SelStart-i, Row]);
end;

end.
