unit dest;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons, Spin;

type
  TDestForm = class(TForm)
    ListBox1: TListBox;
    ComboBox1: TComboBox;
    SpinEdit1: TSpinEdit;
    AddBtn1: TSpeedButton;
    AddBtn2: TSpeedButton;
    DelBtn: TSpeedButton;
    UpBtn: TSpeedButton;
    DownBtn: TSpeedButton;
    OkBtn: TButton;
    CancelBtn: TButton;
    Bevel1: TBevel;
    Label1: TLabel;
    CheckBox1: TCheckBox;
    procedure OkBtnClick(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure AddBtn2Click(Sender: TObject);
    procedure AddBtn1Click(Sender: TObject);
    procedure DelBtnClick(Sender: TObject);
    procedure UpBtnClick(Sender: TObject);
    procedure DownBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    Execute: boolean;
    procedure SetDest(s: string);
    function GetDest: string;
  end;

var
  DestForm: TDestForm;

implementation

{$R *.DFM}

uses
  vars, lists;

procedure TDestForm.SetDest(s: string);
var
  i, Num: integer;
begin
  ListBox1.Clear;
  while s <> '' do
  begin
    i := Pos('/', s);
    if i > 0 then
    begin
      Num := StrToInt(Copy(s, 1, i-1));
      Delete(s, 1, i);
    end else
    begin
      Num := StrToInt(s);
      s := '';
    end;
    ListBox1.Items.AddObject(RoomList.NumToName(Num), TObject(Num));
  end;
end;

function TDestForm.GetDest: string;
var
  i: integer;
  s: string;
begin
  if ListBox1.Items.Count > 0 then
   s := IntToStr(integer(ListBox1.Items.Objects[0]))
  else
   s := '';
  for i := 1 to ListBox1.Items.Count-1 do
   s := s + '/' + IntToStr(integer(ListBox1.Items.Objects[i]));
  Result := s;
end;

procedure TDestForm.OkBtnClick(Sender: TObject);
begin
  Execute := True;
  Close;
end;

procedure TDestForm.CancelBtnClick(Sender: TObject);
begin
  Close;
end;

procedure TDestForm.FormActivate(Sender: TObject);
begin
  Execute := False;
  ActiveControl := ComboBox1;
  ComboBox1.Items := RoomListForm.ListBox1.Items;
end;

procedure TDestForm.AddBtn2Click(Sender: TObject);
var
  Num: integer;
begin
  Num := SpinEdit1.Value;
  if (CheckBox1.Checked) or (ListBox1.ItemIndex < 0) then
   ListBox1.Items.AddObject(IntToStr(Num), TObject(Num))
  else
   ListBox1.Items.InsertObject(ListBox1.ItemIndex, IntToStr(Num), TObject(Num));
end;

procedure TDestForm.AddBtn1Click(Sender: TObject);
var
  Num: integer;
begin
  if ComboBox1.ItemIndex >= 0 then
  begin
    Num := integer(ComboBox1.Items.Objects[ComboBox1.ItemIndex]);
    with ComboBox1 do
     if (CheckBox1.Checked) or (ListBox1.ItemIndex < 0) then
      ListBox1.Items.AddObject(Items[ItemIndex], TObject(Num))
     else
      ListBox1.Items.InsertObject(ListBox1.ItemIndex, Items[ItemIndex], TObject(Num));
  end else
   MessageDlg(' ', mtError, [mbOk], 0);
end;

procedure TDestForm.DelBtnClick(Sender: TObject);
var
  i: integer;
begin
  if ListBox1.ItemIndex >= 0 then
  begin
    if MessageDlg('       ?', mtConfirmation,
                  [mbYes, mbNo], 0) = mrYes then
    begin
      i := ListBox1.ItemIndex;
      ListBox1.Items.Delete(i);
      if i >= ListBox1.Items.Count then
       i := ListBox1.Items.Count-1;
      ListBox1.ItemIndex := i;
    end;
  end else
   MessageDlg(' ', mtError, [mbOk], 0);
end;

procedure TDestForm.UpBtnClick(Sender: TObject);
var
  i, Num: integer;
  s: string;
begin
  i := ListBox1.ItemIndex;
  if i < 0 then
   MessageDlg(' ', mtError, [mbOk], 0)
  else
  if i > 0 then
   with ListBox1 do
  begin
    Num := integer(Items.Objects[i]);
    s := Items[i];
    Items.Objects[i] := Items.Objects[i-1];
    Items[i] := Items[i-1];
    Items.Objects[i-1] := TObject(Num);
    Items[i-1] := s;
    ItemIndex := i-1;
  end;
end;

procedure TDestForm.DownBtnClick(Sender: TObject);
var
  i, Num: integer;
  s: string;
begin
  i := ListBox1.ItemIndex;
  if i < 0 then
   MessageDlg(' ', mtError, [mbOk], 0)
  else
  with ListBox1 do
   if i < Items.Count-1 then
  begin
    Num := integer(Items.Objects[i]);
    s := Items[i];
    Items.Objects[i] := Items.Objects[i+1];
    Items[i] := Items[i+1];
    Items.Objects[i+1] := TObject(Num);
    Items[i+1] := s;
    ItemIndex := i+1;
  end;
end;

end.
