unit hints;

interface

procedure LoadHints(const FileName: string);

implementation

uses
  main, Classes, Controls, SysUtils;

const
  HintCount = 150;

  HintNameArr: array [1..HintCount] of string = (
   {zones}
   'Z_List:', 'Z_NewZone:', 'Z_Zone:', 'Z_Name:', 'Z_RepopTime:', 'Z_Repop:',
   'Z_Obj:', 'Z_Del:', 'Z_ZoneFilename:', 'Z_RoomFilename:', 'Z_ObjFilename:',
   'Z_MobFilename:', 'Z_ShopFilename:', 'Z_TrigFilename:', 'Z_Error:', 'Z_Source:',
   {rooms}
   'R_ID:', 'R_Desc:', 'R_FullDesc:', 'R_FullDesc1:', 'R_FullDesc2:', 'R_FullDesc3:',
   'R_FullDesc4:', 'R_FullDesc5:', 'R_FullDesc6:', 'R_FullDesc7:', 'R_FullDesc8:',
   'R_FullDesc9:', 'R_FullDesc10:', 'R_DescCheck:', 'R_Sector:', 'R_ExitN:',
   'R_ExitE:', 'R_ExitS:', 'R_ExitW:', 'R_ExitU:', 'R_ExitD:', 'R_MapRooms:',
   'R_MapAutoLink:', 'R_DelFromMap:', 'R_ExitNPanel', 'R_ExitEPanel', 'R_ExitSPanel',
   'R_ExitWPanel', 'R_ExitUPanel', 'R_ExitDPanel', 'R_Object:', 'R_OObj:', 'R_Mob:',
   'R_MFol:', 'R_MMax:', 'R_MObj:', 'R_ODel:', 'R_Trigger:', 'R_MMaxW:',
   {objects}
   'O_ID:', 'O_Alias:', 'O_Name1:', 'O_Name2:', 'O_Name3:', 'O_Name4:', 'O_Name5:',
   'O_Name6:', 'O_Desc:', 'O_AddDesc:', 'O_Kind:', 'O_Timer:', 'O_Weight:',
   'O_Price:', 'O_RentInv:', 'O_RentWear:', 'O_Skill:', 'O_Material:',
   'O_MaxInWorld:', 'O_Wear:', 'O_WearLeft:', 'O_Spell:', 'O_SpellLevel:',
   'O_Type:', 'O_CDup:',
   {mobs}
   'M_ID:', 'M_Alias:', 'M_Name1:', 'M_Name2:', 'M_Name3:', 'M_Name4:', 'M_Name5:',
   'M_Name6:', 'M_Desc:', 'M_FullDesc:', 'M_CDup:', 'M_FullDescB:', 'M_Level:',
   'M_Thac0:', 'M_AC:', 'M_HP1:', 'M_HP2:', 'M_HP3:', 'M_Damage1:', 'M_Damage2:',
   'M_Damage3:', 'M_Money1:', 'M_Money2:', 'M_Money3:', 'M_Exp:', 'M_Sex:',
   'M_State1:', 'M_State2:', 'M_Align:', 'M_LikeWork:', 'M_ExtraAttack:', 'M_Class:',
   'M_BareHand:', 'M_Helper:', 'M_Size:', 'M_MaxInWorld:', 'M_Str:', 'M_Int:',
   'M_Wiz:', 'M_Dex:', 'M_Con:', 'M_Cha:', 'M_Destination:', 'M_DestBtn:',
   {shops}
   'S_ID:', 'S_Seller:', 'S_Sell:', 'S_Room:', 'S_Buy:', 'S_Change:', 'S_ProfitSell:',
   'S_ProfitBuy:', 'S_ProfitChange:', 'S_Open1:', 'S_Close1:', 'S_Open2:',
   'S_Close2:', 'S_Emotion:', 'S_Msg1:', 'S_Msg2:', 'S_Msg3:', 'S_Msg4:', 'S_Msg5:',
   'S_Msg6:', 'S_Msg7:',
   {triggers}
   'T_ID:', 'T_Name:', 'T_Class:', 'T_NumArg:', 'T_Arg:'
  );

procedure LoadHints(const FileName: string);
var
  tmpStrs: TStringList;
  s: string;
  i, j: integer;
  ControlArr: array [1..HintCount] of TControl;
begin
  with MainForm do
  begin
    i := 1;
   {zones}
    ControlArr[i] := Z_ListBox; Inc(i);
    ControlArr[i] := Z_NewZoneEdit; Inc(i);
    ControlArr[i] := Z_ZoneEdit; Inc(i);
    ControlArr[i] := Z_NameEdit; Inc(i);
    ControlArr[i] := Z_RepopTimeEdit; Inc(i);
    ControlArr[i] := Z_RepopComboBox; Inc(i);
    ControlArr[i] := Z_ObjCheckListBox; Inc(i);
    ControlArr[i] := Z_DelMobCheckListBox; Inc(i);
    ControlArr[i] := Z_ZoneFilenameEdit; Inc(i);
    ControlArr[i] := Z_RoomFilenameEdit; Inc(i);
    ControlArr[i] := Z_ObjFilenameEdit; Inc(i);
    ControlArr[i] := Z_MobFilenameEdit; Inc(i);
    ControlArr[i] := Z_ShopFilenameEdit; Inc(i);
    ControlArr[i] := Z_TrigFilenameEdit; Inc(i);
    ControlArr[i] := Z_ErrorListBox; Inc(i);
    ControlArr[i] := Z_SourceMemo; Inc(i);
   {rooms}
    ControlArr[i] := R_IDComboBox; Inc(i);
    ControlArr[i] := R_DescEdit; Inc(i);
    ControlArr[i] := R_FullDescMemo; Inc(i);
    ControlArr[i] := R_FullDescMemo1; Inc(i);
    ControlArr[i] := R_FullDescMemo2; Inc(i);
    ControlArr[i] := R_FullDescMemo3; Inc(i);
    ControlArr[i] := R_FullDescMemo4; Inc(i);
    ControlArr[i] := R_FullDescMemo5; Inc(i);
    ControlArr[i] := R_FullDescMemo6; Inc(i);
    ControlArr[i] := R_FullDescMemo7; Inc(i);
    ControlArr[i] := R_FullDescMemo8; Inc(i);
    ControlArr[i] := R_FullDescMemo9; Inc(i);
    ControlArr[i] := R_FullDescMemo10; Inc(i);
    ControlArr[i] := R_DescCheckBox; Inc(i);
    ControlArr[i] := R_SectorComboBox; Inc(i);
    ControlArr[i] := R_ExitNEdit; Inc(i);
    ControlArr[i] := R_ExitEEdit; Inc(i);
    ControlArr[i] := R_ExitSEdit; Inc(i);
    ControlArr[i] := R_ExitWEdit; Inc(i);
    ControlArr[i] := R_ExitUEdit; Inc(i);
    ControlArr[i] := R_ExitDEdit; Inc(i);
    ControlArr[i] := MapRoomsListBox; Inc(i);
    ControlArr[i] := MapAutoLinkCheckBox; Inc(i);
    ControlArr[i] := R_DelFromMapBtn; Inc(i);
    ControlArr[i] := R_ExitNPanel; Inc(i);
    ControlArr[i] := R_ExitEPanel; Inc(i);
    ControlArr[i] := R_ExitSPanel; Inc(i);
    ControlArr[i] := R_ExitWPanel; Inc(i);
    ControlArr[i] := R_ExitUPanel; Inc(i);
    ControlArr[i] := R_ExitDPanel; Inc(i);
    ControlArr[i] := R_ObjectCheckListBox; Inc(i);
    ControlArr[i] := R_OObjCheckListBox; Inc(i);
    ControlArr[i] := R_MobCheckListBox; Inc(i);
    ControlArr[i] := R_MFolComboBox; Inc(i);
    ControlArr[i] := R_MMaxEdit; Inc(i);
    ControlArr[i] := R_MObjCheckListBox; Inc(i);
    ControlArr[i] := R_ODelCheckListBox; Inc(i);
    ControlArr[i] := R_TriggerListBox; Inc(i);
    ControlArr[i] := R_MMaxWLabel; Inc(i);
   {objects}
    ControlArr[i] := O_IDComboBox; Inc(i);
    ControlArr[i] := O_AliasEdit; Inc(i);
    ControlArr[i] := O_Name1Edit; Inc(i);
    ControlArr[i] := O_Name2Edit; Inc(i);
    ControlArr[i] := O_Name3Edit; Inc(i);
    ControlArr[i] := O_Name4Edit; Inc(i);
    ControlArr[i] := O_Name5Edit; Inc(i);
    ControlArr[i] := O_Name6Edit; Inc(i);
    ControlArr[i] := O_DescEdit; Inc(i);
    ControlArr[i] := O_AddDescEdit; Inc(i);
    ControlArr[i] := O_KindComboBox; Inc(i);
    ControlArr[i] := O_TimerEdit; Inc(i);
    ControlArr[i] := O_WeightEdit; Inc(i);
    ControlArr[i] := O_PriceEdit; Inc(i);
    ControlArr[i] := O_RentInvEdit; Inc(i);
    ControlArr[i] := O_RentWearEdit; Inc(i);
    ControlArr[i] := O_SkillComboBox; Inc(i);
    ControlArr[i] := O_MaterialComboBox; Inc(i);
    ControlArr[i] := O_MaxInWorldEdit; Inc(i);
    ControlArr[i] := O_WearComboBox; Inc(i);
    ControlArr[i] := O_WearEdit; Inc(i);
    ControlArr[i] := O_SpellComboBox; Inc(i);
    ControlArr[i] := O_SpellLevelEdit; Inc(i);
    ControlArr[i] := O_TypeComboBox; Inc(i);
    ControlArr[i] := O_CDupBtn; Inc(i);
   {mobs}
    ControlArr[i] := M_IDComboBox; Inc(i);
    ControlArr[i] := M_AliasEdit; Inc(i);
    ControlArr[i] := M_Name1Edit; Inc(i);
    ControlArr[i] := M_Name2Edit; Inc(i);
    ControlArr[i] := M_Name3Edit; Inc(i);
    ControlArr[i] := M_Name4Edit; Inc(i);
    ControlArr[i] := M_Name5Edit; Inc(i);
    ControlArr[i] := M_Name6Edit; Inc(i);
    ControlArr[i] := M_DescEdit; Inc(i);
    ControlArr[i] := M_FullDescEdit; Inc(i);
    ControlArr[i] := M_CDupBtn; Inc(i);
    ControlArr[i] := M_FullDescBtn; Inc(i);
    ControlArr[i] := M_LevelComboBox; Inc(i);
    ControlArr[i] := M_Thac0ComboBox; Inc(i);
    ControlArr[i] := M_ACComboBox; Inc(i);
    ControlArr[i] := M_HP1Edit; Inc(i);
    ControlArr[i] := M_HP2Edit; Inc(i);
    ControlArr[i] := M_HP3Edit; Inc(i);
    ControlArr[i] := M_Damage1Edit; Inc(i);
    ControlArr[i] := M_Damage2Edit; Inc(i);
    ControlArr[i] := M_Damage3Edit; Inc(i);
    ControlArr[i] := M_Money1Edit; Inc(i);
    ControlArr[i] := M_Money2Edit; Inc(i);
    ControlArr[i] := M_Money3Edit; Inc(i);
    ControlArr[i] := M_ExpEdit; Inc(i);
    ControlArr[i] := M_SexComboBox; Inc(i);
    ControlArr[i] := M_State1ComboBox; Inc(i);
    ControlArr[i] := M_State2ComboBox; Inc(i);
    ControlArr[i] := M_AlignComboBox; Inc(i);
    ControlArr[i] := M_LikeWorkComboBox; Inc(i);
    ControlArr[i] := M_ExtraAttackComboBox; Inc(i);
    ControlArr[i] := M_ClassComboBox; Inc(i);
    ControlArr[i] := M_BareHandComboBox; Inc(i);
    ControlArr[i] := M_HelperListBox; Inc(i);
    ControlArr[i] := M_SizeEdit; Inc(i);
    ControlArr[i] := M_MaxInWorldEdit; Inc(i);
    ControlArr[i] := M_StrComboBox; Inc(i);
    ControlArr[i] := M_IntComboBox; Inc(i);
    ControlArr[i] := M_WisComboBox; Inc(i);
    ControlArr[i] := M_DexComboBox; Inc(i);
    ControlArr[i] := M_ConComboBox; Inc(i);
    ControlArr[i] := M_ChaComboBox; Inc(i);
    ControlArr[i] := M_DestinationEdit; Inc(i);
    ControlArr[i] := M_DestinationBtn; Inc(i);
   {shops}
    ControlArr[i] := S_IDComboBox; Inc(i);
    ControlArr[i] := S_SellerEdit; Inc(i);
    ControlArr[i] := S_SellListBox; Inc(i);
    ControlArr[i] := S_RoomListBox; Inc(i);
    ControlArr[i] := S_BuyListBox; Inc(i);
    ControlArr[i] := S_ChangeListBox; Inc(i);
    ControlArr[i] := S_ProfitSellEdit; Inc(i);
    ControlArr[i] := S_ProfitBuyEdit; Inc(i);
    ControlArr[i] := S_ProfitChangeEdit; Inc(i);
    ControlArr[i] := S_Open1ComboBox; Inc(i);
    ControlArr[i] := S_Close1ComboBox; Inc(i);
    ControlArr[i] := S_Open2ComboBox; Inc(i);
    ControlArr[i] := S_Close2ComboBox; Inc(i);
    ControlArr[i] := S_EmotionEdit; Inc(i);
    ControlArr[i] := S_Msg1Edit; Inc(i);
    ControlArr[i] := S_Msg2Edit; Inc(i);
    ControlArr[i] := S_Msg3Edit; Inc(i);
    ControlArr[i] := S_Msg4Edit; Inc(i);
    ControlArr[i] := S_Msg5Edit; Inc(i);
    ControlArr[i] := S_Msg6Edit; Inc(i);
    ControlArr[i] := S_Msg7Edit; Inc(i);
   {triggers}
    ControlArr[i] := T_IDComboBox; Inc(i);
    ControlArr[i] := T_NameEdit; Inc(i);
    ControlArr[i] := T_ClassComboBox; Inc(i);
    ControlArr[i] := T_NumArgEdit; Inc(i);
    ControlArr[i] := T_ArgEdit;
  end;
  try
    tmpStrs := TStringList.Create;
    tmpStrs.LoadFromFile(FileName);
    for i := 0 to tmpStrs.Count-1 do
     for j := 1 to HintCount do
      if Pos(HintNameArr[j], tmpStrs[i]) = 1 then
    begin
      s := tmpStrs[i];
      Delete(s, 1, Length(HintNameArr[j])+1);
      ControlArr[j].Hint := s;
      ControlArr[j].ShowHint := True;
      break;
    end;
  finally
    tmpStrs.Free;
  end;
end;

end.
