unit roomobj;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, checklst, vars, ExtCtrls;

type
  TRoomObjForm = class(TForm)
    Label1: TLabel;
    ObjectListBox: TListBox;
    OkBtn: TButton;
    ObjectEdit: TSpinEdit;
    ParamGroupBox: TGroupBox;
    MobComboBox: TComboBox;
    IFFlagCheckBox: TCheckBox;
    AddBtn: TButton;
    CancelBtn: TButton;
    Bevel1: TBevel;
    MobCheckBox: TCheckBox;
    PanelPercent: TPanel;
    Label2: TLabel;
    PercentEdit: TSpinEdit;
    Label4: TLabel;
    procedure CancelBtnClick(Sender: TObject);
    procedure AddBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure OkBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure MobCheckBoxClick(Sender: TObject);
  private
    { Private declarations }
  public
    Execute: boolean;
    procedure SetObject(const LinkObj: TLinkObj);
    procedure GetObject(var LinkObj: TLinkObj);
    procedure HidePanels;
    procedure ShowPanels;
  end;

var
  RoomObjForm: TRoomObjForm;

implementation

{$R *.DFM}
uses
  main;

procedure TRoomObjForm.FormCreate(Sender: TObject);
begin
  MainForm.LoadFromFileToComboBox('ZON_Equipped', MobComboBox, 0, 0);
end;

procedure TRoomObjForm.FormActivate(Sender: TObject);
begin
  Execute := False;
end;

procedure TRoomObjForm.CancelBtnClick(Sender: TObject);
begin
  Close;
end;

procedure TRoomObjForm.AddBtnClick(Sender: TObject);
begin
  if ObjectEdit.Value <> 0 then
  begin
    Execute := True;
    Close;
  end else
   MessageDlg(' ', mtError, [mbOk], 0);
end;

procedure TRoomObjForm.OkBtnClick(Sender: TObject);
begin
  if ObjectListBox.ItemIndex >= 0 then
   ObjectEdit.Value := integer(ObjectListBox.Items.Objects[ObjectListBox.ItemIndex])
  else
   MessageDlg(' ', mtError, [mbOk], 0);
end;

procedure TRoomObjForm.SetObject(const LinkObj: TLinkObj);
begin
  with LinkObj do
  begin
    ObjectListBox.ItemIndex := ObjectListBox.Items.IndexOfObject(TObject(Number));
    ObjectEdit.Value := Number;
    IFFlagCheckBox.Checked := IFFlag;
    MobCheckBox.Checked := Where = -1;
    MobComboBox.ItemIndex := MobComboBox.Items.IndexOfObject(TObject(Where));
    PercentEdit.Value := Prob;
  end;
end;

procedure TRoomObjForm.GetObject(var LinkObj: TLinkObj);
begin
  with LinkObj do
  begin
    Number := ObjectEdit.Value;
    IFFlag := IFFlagCheckBox.Checked;
    if MobCheckBox.Checked then
     Where := -1
    else
     Where := integer(MobComboBox.Items.Objects[MobComboBox.ItemIndex]);
    Prob := PercentEdit.Value;
  end;
end;

procedure TRoomObjForm.MobCheckBoxClick(Sender: TObject);
begin
  MobComboBox.Enabled := not MobCheckBox.Checked;
end;

procedure TRoomObjForm.HidePanels;
begin
  ParamGroupBox.Visible := False;
  PanelPercent.Visible := False;
  IFFlagCheckBox.Visible := False;
  ObjectListBox.Height := 289;
  OkBtn.Top := 328;
  ObjectEdit.Top := 328;
end;

procedure TRoomObjForm.ShowPanels;
begin
  ParamGroupBox.Visible := True;
  PanelPercent.Visible := True;
  IFFlagCheckBox.Visible := True;
  ObjectListBox.Height := 233;
  OkBtn.Top := 264;
  ObjectEdit.Top := 264;
end;

end.
