unit templets;

interface

uses
  Classes;

type
  TObjTemplet = class (TStringList)
    constructor Create(const FileName: string);
    procedure LoadFromFile(const FileName: string); override;
    destructor Destroy; override;
  end;

  TMobTemplet = class (TStringList)
    constructor Create(const FileName: string);
    procedure LoadFromFile(const FileName: string); override;
    destructor Destroy; override;
  end;

  TShopTemplet = class (TStringList)
    constructor Create(const FileName: string);
    procedure LoadFromFile(const FileName: string); override;
    destructor Destroy; override;
  end;

  TTrigTemplet = class (TStringList)
    constructor Create(const FileName: string);
    procedure LoadFromFile(const FileName: string); override;
    destructor Destroy; override;
  end;

  TRoomTemplet = class (TStringList)
    constructor Create(const FileName: string);
    procedure LoadFromFile(const FileName: string); override;
    destructor Destroy; override;
  end;

var
  ObjTemplet: TObjTemplet;
  MobTemplet: TMobTemplet;
  ShopTemplet: TShopTemplet;
  TrigTemplet: TTrigTemplet;
  RoomTemplet: TRoomTemplet;

implementation

uses
  main, vars, Dialogs, SysUtils, StrUtils;

{ TObjTemplet }

constructor TObjTemplet.Create(const FileName: string);
begin
  inherited Create;
  LoadFromFile(FileName);
end;

procedure TObjTemplet.LoadFromFile(const FileName: string);
var
  f: TextFile;
  Obj: TObj;
  s: string;
  AddP: TAddParam;
  i: integer;
begin
  try
    FileCounter := -1;
    AssignFile(f, FileName); Reset(f);
    try
      Clear;
      FileCounter := 0;
      while not Eof(f) do
      begin
        ReadF(f, s);
        if Length(s) <> 0 then
        if s[1] = '#' then
        begin
          Obj := TObj.Create(0);
          AddObject(Copy(s, 2, Length(s)-2), Obj);
        end
        else if Pos('Alias:', s) = 1 then
         Obj.Alias := Copy(s, 8, Length(s)-8)
        else if Pos('Imen:', s) = 1 then
         Obj.Imen := Copy(s, 7, Length(s)-7)
        else if Pos('Rod:', s) = 1 then
         Obj.Rod := Copy(s, 6, Length(s)-6)
        else if Pos('Dat:', s) = 1 then
         Obj.Dat := Copy(s, 6, Length(s)-6)
        else if Pos('Vin:', s) = 1 then
         Obj.Vin := Copy(s, 6, Length(s)-6)
        else if Pos('Tvor:', s) = 1 then
         Obj.Tvor := Copy(s, 7, Length(s)-7)
        else if Pos('Pred:', s) = 1 then
         Obj.Pred := Copy(s, 7, Length(s)-7)
        else if Pos('Desc:', s) = 1 then
         Obj.Desc := Copy(s, 7, Length(s)-7)
        else if Pos('Action:', s) = 1 then
         Obj.Action := Copy(s, 9, Length(s)-9)
        else if Pos('TrenSkill:', s) = 1 then
         Obj.TrenSkill := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('MagicVector:', s) = 1 then
         Obj.MagicVector := Copy(s, 14, Length(s)-14)
        else if Pos('MaxDurab:', s) = 1 then
         Obj.MaxDurab := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('CurrDurab:', s) = 1 then
         Obj.CurrDurab := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('Material:', s) = 1 then
         Obj.Material := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('Pol:', s) = 1 then
         Obj.Pol := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('Timer:', s) = 1 then
         Obj.Timer := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('Spell:', s) = 1 then
         Obj.Spell := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('SpellLevel:', s) = 1 then
         Obj.SpellLevel := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('Effects:', s) = 1 then
         Obj.Effects := Copy(s, 10, Length(s)-10)
        else if Pos('Discomfort:', s) = 1 then
         Obj.Discomfort := Copy(s, 13, Length(s)-13)
        else if Pos('Bans:', s) = 1 then
         Obj.Bans := Copy(s, 7, Length(s)-7)
        else if Pos('Kind:', s) = 1 then
         Obj.Kind := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('Flags:', s) = 1 then
         Obj.Flags := Copy(s, 8, Length(s)-8)
        else if Pos('WearFlags:', s) = 1 then
         Obj.WearFlags := Copy(s, 12, Length(s)-12)
        else if Pos('Param1:', s) = 1 then
         Obj.Param1 := Copy(s, 10, Length(s)-10)
        else if Pos('Param2:', s) = 1 then
         Obj.Param2 := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('Param3:', s) = 1 then
         Obj.Param3 := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('Param4:', s) = 1 then
         Obj.Param4 := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('Weight:', s) = 1 then
         Obj.Weight := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('Price:', s) = 1 then
         Obj.Price := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('RentInv:', s) = 1 then
         Obj.RentInv := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('RentWear:', s) = 1 then
         Obj.RentWear := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('MaxInWorld:', s) = 1 then
         Obj.MaxInWorld := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('AddParam:', s) = 1 then
        begin
          AddP.Number := StrToInt(ExtractWord(2, s, [' ', #9]));
          AddP.Value := StrToInt(ExtractWord(3, s, [' ', #9]));
          Obj.AddParam.Add(TObject(AddP));
        end
        else if Pos('Triggers:', s) = 1 then
        begin
          i := StrToInt(ExtractWord(2, s, [' ', #9]));
          Obj.Triggers.Add(TObject(i));
        end;
      end;
      FileCounter := -2;
    finally
      CloseFile(f);
    end;
  except
    MessageDlg('    '#13#10': ' + FileName +
                 FileErrMsg(FileCounter), mtError, [mbOk], 0);
  end;
end;

destructor TObjTemplet.Destroy;
var
  i: integer;
begin
  for i := 0 to Count-1 do
   TObj(Objects[i]).Free;
  inherited Destroy;
end;

{ TMobTemplet }

constructor TMobTemplet.Create(const FileName: string);
begin
  inherited Create;
  LoadFromFile(FileName);
end;

procedure TMobTemplet.LoadFromFile(const FileName: string);
var
  f: TextFile;
  Mob: TMob;
  s: string;
  Dice: TDice;
  i: integer;
  Skill: TSkill;
  Spell: TSpell;
begin
  try
    FileCounter := -1;
    AssignFile(f, FileName); Reset(f);
    try
      Clear;
      FileCounter := 0;
      while not Eof(f) do
      begin
        ReadF(f, s);
        if Length(s) <> 0 then
        if s[1] = '#' then
        begin
          Mob := TMob.Create(0);
          AddObject(Copy(s, 2, Length(s)-2), Mob);
        end
        else if Pos('Alias:', s) = 1 then
         Mob.Alias := Copy(s, 8, Length(s)-8)
        else if Pos('Imen:', s) = 1 then
         Mob.Imen := Copy(s, 7, Length(s)-7)
        else if Pos('Rod:', s) = 1 then
         Mob.Rod := Copy(s, 6, Length(s)-6)
        else if Pos('Dat:', s) = 1 then
         Mob.Dat := Copy(s, 6, Length(s)-6)
        else if Pos('Vin:', s) = 1 then
         Mob.Vin := Copy(s, 6, Length(s)-6)
        else if Pos('Tvor:', s) = 1 then
         Mob.Tvor := Copy(s, 7, Length(s)-7)
        else if Pos('Pred:', s) = 1 then
         Mob.Pred := Copy(s, 7, Length(s)-7)
        else if Pos('Desc:', s) = 1 then
         Mob.Desc := Copy(s, 7, Length(s)-7)
        else if Pos('Look:', s) = 1 then
         Mob.Look.Add(Copy(s, 7, Length(s)-7))
        else if Pos('Flags:', s) = 1 then
         Mob.Flags := Copy(s, 8, Length(s)-8)
        else if Pos('Affects:', s) = 1 then
         Mob.Affects := Copy(s, 10, Length(s)-10)
        else if Pos('Align:', s) = 1 then
         Mob.Align := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('Level:', s) = 1 then
         Mob.Level := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('Hitroll:', s) = 1 then
         Mob.hitroll := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('AC:', s) = 1 then
         Mob.AC := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('Hits:', s) = 1 then
        begin
          Dice.n := StrToInt(ExtractWord(2, s, [' ', #9]));
          Dice.d := StrToInt(ExtractWord(3, s, [' ', #9]));
          Dice.a := StrToInt(ExtractWord(4, s, [' ', #9]));
          Mob.Hits := Dice;
        end
        else if Pos('Damage:', s) = 1 then
        begin
          Dice.n := StrToInt(ExtractWord(2, s, [' ', #9]));
          Dice.d := StrToInt(ExtractWord(3, s, [' ', #9]));
          Dice.a := StrToInt(ExtractWord(4, s, [' ', #9]));
          Mob.Damage := Dice;
        end
        else if Pos('Money:', s) = 1 then
        begin
          Dice.n := StrToInt(ExtractWord(2, s, [' ', #9]));
          Dice.d := StrToInt(ExtractWord(3, s, [' ', #9]));
          Dice.a := StrToInt(ExtractWord(4, s, [' ', #9]));
          Mob.Money := Dice;
        end
        else if Pos('Exp:', s) = 1 then
         Mob.Exp := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('PosLoad:', s) = 1 then
         Mob.PosLoad := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('PosDefault:', s) = 1 then
         Mob.PosDefault := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('Pol:', s) = 1 then
         Mob.Pol := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('BareHandAttack:', s) = 1 then
         Mob.BareHandAttack := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('Destination:', s) = 1 then
        begin
          if Mob.Destination = '' then
           Mob.Destination := ExtractWord(2, s, [' '])
          else
           Mob.Destination := Mob.Destination + '/' + ExtractWord(2, s, [' ']);
        end
        else if Pos('Str:', s) = 1 then
         Mob.Str := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('Int:', s) = 1 then
         Mob.Int := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('Wis:', s) = 1 then
         Mob.Wis := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('Dex:', s) = 1 then
         Mob.Dex := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('Con:', s) = 1 then
         Mob.Con := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('Cha:', s) = 1 then
         Mob.Cha := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('LikeWork:', s) = 1 then
         Mob.LikeWork := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('MaxFactor:', s) = 1 then
         Mob.MaxFactor := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('ExtraAttack:', s) = 1 then
         Mob.ExtraAttack := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('Model:', s) = 1 then
         Mob.Model := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('Size:', s) = 1 then
         Mob.Size := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('Height:', s) = 1 then
         Mob.Height := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('Weight:', s) = 1 then
         Mob.Weight := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('Special:', s) = 1 then
         Mob.Special := Copy(s, 10, Length(s)-10)
        else if Pos('MaxInWorld:', s) = 1 then
         Mob.MaxInWorld := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('Spells:', s) = 1 then
        begin
          Spell.Number := StrToInt(ExtractWord(2, s, [' ']));
          i := Mob.FindSpellNum(Spell.Number);
          if i >= 0 then
          begin
            Spell.Qty := TSpell(Mob.Spells.Items[i]).Qty + 1;
            Mob.Spells.Items[i] := TObject(Spell);
          end else
          begin
            Spell.Qty := 1;
            Mob.Spells.Add(TObject(Spell));
          end;
        end
        else if Pos('Skills:', s) = 1 then
        begin
          Skill.Number := StrToInt(ExtractWord(2, s, [' ']));
          Skill.Percent := StrToInt(ExtractWord(3, s, [' ']));
          Mob.Skills.Add(TObject(Skill));
        end
        else if Pos('Helper:', s) = 1 then
        begin
          i := StrToInt(ExtractWord(2, s, [' ', #9]));
          Mob.Triggers.Add(TObject(i));
        end
        else if Pos('Triggers:', s) = 1 then
        begin
          i := StrToInt(ExtractWord(2, s, [' ', #9]));
          Mob.Triggers.Add(TObject(i));
        end;
      end;
      FileCounter := -2;
    finally
      CloseFile(f);
    end;
  except
    MessageDlg('    '#13#10': ' + FileName +
                 FileErrMsg(FileCounter), mtError, [mbOk], 0);
  end;
end;

destructor TMobTemplet.Destroy;
var
  i: integer;
begin
  for i := 0 to Count-1 do
   TMob(Objects[i]).Free;
  inherited Destroy;
end;

{ TShopTemplet }

constructor TShopTemplet.Create(const FileName: string);
begin
  inherited Create;
  LoadFromFile(FileName);
end;

procedure TShopTemplet.LoadFromFile(const FileName: string);
var
  f: TextFile;
  Shop: TShop;
  s, s1: string;
  i, j: integer;
begin
  try
    FileCounter := -1;
    AssignFile(f, FileName); Reset(f);
    try
      Clear;
      FileCounter := 0;
      while not Eof(f) do
      begin
        ReadF(f, s);
        if Length(s) <> 0 then
        if s[1] = '#' then
        begin
          Shop := TShop.Create(0);
          AddObject(Copy(s, 2, Length(s)-2), Shop);
        end
        else if Pos('Goods:', s) = 1 then
        begin
          i := StrToInt(ExtractWord(2, s, [' ', #9]));
          Shop.Goods.Add(TObject(i));
        end
        else if Pos('CoeffSell:', s) = 1 then
         Val(ExtractWord(2, s, [' ', #9]), Shop.CoeffSell, i)
        else if Pos('CoeffBuy:', s) = 1 then
         Val(ExtractWord(2, s, [' ', #9]), Shop.CoeffBuy, i)
        else if Pos('CoeffChange:', s) = 1 then
         Val(ExtractWord(2, s, [' ', #9]), Shop.CoeffChange, i)
        else if Pos('GoodsBuy:', s) = 1 then
        begin
          s1 := ExtractWord(2, s, [' ']);
          if s1[Length(s1)] = '~' then
          begin
            System.Delete(s1, Length(s1), 1);
            i := -1;
          end else
          begin
            i := StrToInt(s1);
            j := MainForm.S_BuyComboBox.Items.IndexOfObject(TObject(i));
            if j >= 0 then
             s1 := MainForm.S_BuyComboBox.Items[j];
          end;
          Shop.GoodsBuy.AddObject(s1, TObject(i));
        end
        else if Pos('GoodsChange:', s) = 1 then
        begin
          s1 := ExtractWord(2, s, [' ']);
          if s1[Length(s1)] = '~' then
          begin
            System.Delete(s1, Length(s1), 1);
            i := -1;
          end else
          begin
            i := StrToInt(s1);
            j := MainForm.S_ChangeComboBox.Items.IndexOfObject(TObject(i));
            if j >= 0 then
             s1 := MainForm.S_ChangeComboBox.Items[j];
          end;
          Shop.GoodsChange.AddObject(s1, TObject(i));
        end
        else if Pos('Msg1:', s) = 1 then
         Shop.Msg1 := Copy(s, 7, Length(s)-7)
        else if Pos('Msg2:', s) = 1 then
         Shop.Msg2 := Copy(s, 7, Length(s)-7)
        else if Pos('Msg3:', s) = 1 then
         Shop.Msg3 := Copy(s, 7, Length(s)-7)
        else if Pos('Msg4:', s) = 1 then
         Shop.Msg4 := Copy(s, 7, Length(s)-7)
        else if Pos('Msg5:', s) = 1 then
         Shop.Msg5 := Copy(s, 7, Length(s)-7)
        else if Pos('Msg6:', s) = 1 then
         Shop.Msg6 := Copy(s, 7, Length(s)-7)
        else if Pos('Msg7:', s) = 1 then
         Shop.Msg7 := Copy(s, 7, Length(s)-7)
        else if Pos('Emotion:', s) = 1 then
         Shop.Emotion := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('BitVector:', s) = 1 then
         Shop.BitVector := Copy(s, 12, Length(s)-12)
        else if Pos('Seller:', s) = 1 then
         Shop.Seller := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('NotSellVector:', s) = 1 then
         Shop.NotSellVector := Copy(s, 16, Length(s)-16)
        else if Pos('Rooms:', s) = 1 then
        begin
          i := StrToInt(ExtractWord(2, s, [' ', #9]));
          Shop.Rooms.Add(TObject(i));
        end
        else if Pos('Open1:', s) = 1 then
         Shop.Open1 := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('Close1:', s) = 1 then
         Shop.Close1 := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('Open2:', s) = 1 then
         Shop.Open2 := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('Close2:', s) = 1 then
         Shop.Close2 := StrToInt(ExtractWord(2, s, [' ', #9]));
      end;
      FileCounter := -2;
    finally
      CloseFile(f);
    end;
  except
    MessageDlg('    '#13#10': ' + FileName +
                 FileErrMsg(FileCounter), mtError, [mbOk], 0);
  end;
end;

destructor TShopTemplet.Destroy;
var
  i: integer;
begin
  for i := 0 to Count-1 do
   TShop(Objects[i]).Free;
  inherited Destroy;
end;

{ TTrigTemplet }

constructor TTrigTemplet.Create(const FileName: string);
begin
  inherited Create;
  LoadFromFile(FileName);
end;

procedure TTrigTemplet.LoadFromFile(const FileName: string);
var
  f: TextFile;
  Trig: TTrigger;
  s: string;
begin
  try
    FileCounter := -1;
    AssignFile(f, FileName); Reset(f);
    try
      Clear;
      FileCounter := 0;
      while not Eof(f) do
      begin
        ReadF(f, s);
        if Length(s) <> 0 then
        if s[1] = '#' then
        begin
          Trig := TTrigger.Create(0);
          AddObject(Copy(s, 2, Length(s)-2), Trig);
        end
        else if Pos('Name:', s) = 1 then
         Trig.Name := Copy(s, 7, Length(s)-7)
        else if Pos('Model:', s) = 1 then
         Trig.Model := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('Flags:', s) = 1 then
         Trig.Flags := Copy(s, 8, Length(s)-8)
        else if Pos('NumParam:', s) = 1 then
         Trig.NumParam := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('StrParam:', s) = 1 then
         Trig.StrParam := Copy(s, 11, Length(s)-11);
      end;
      FileCounter := -2;
    finally
      CloseFile(f);
    end;
  except
    MessageDlg('    '#13#10': ' + FileName +
                 FileErrMsg(FileCounter), mtError, [mbOk], 0);
  end;
end;

destructor TTrigTemplet.Destroy;
var
  i: integer;
begin
  for i := 0 to Count-1 do
   TTrigger(Objects[i]).Free;
  inherited Destroy;
end;

{ TRoomTemplet }

constructor TRoomTemplet.Create(const FileName: string);
begin
  inherited Create;
  LoadFromFile(FileName);
end;

procedure TRoomTemplet.LoadFromFile(const FileName: string);
var
  f: TextFile;
  Room: TRoom;
  s: string;
  i: integer;
  RoomMob: TRoomMob;
  RoomObj: TRoomObj;
begin
  try
    FileCounter := -1;
    AssignFile(f, FileName); Reset(f);
    try
      Clear;
      FileCounter := 0;
      while not Eof(f) do
      begin
        ReadF(f, s);
        if Length(s) <> 0 then
        if s[1] = '#' then
        begin
          Room := TRoom.Create(0);
          AddObject(Copy(s, 2, Length(s)-2), Room);
        end
        else if Pos('Name:', s) = 1 then
         Room.Name := Copy(s, 7, Length(s)-7)
        else if Pos('Desc:', s) = 1 then
         Room.Desc.Add(Copy(s, 7, Length(s)-7))
        else if Pos('Flags:', s) = 1 then
         Room.Flags := Copy(s, 8, Length(s)-8)
        else if Pos('Sector:', s) = 1 then
         Room.Sector := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('ExitN:', s) = 1 then
         Room.Exits[0].ExitRoom := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('ExitE:', s) = 1 then
         Room.Exits[1].ExitRoom := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('ExitS:', s) = 1 then
         Room.Exits[2].ExitRoom := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('ExitW:', s) = 1 then
         Room.Exits[3].ExitRoom := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('ExitU:', s) = 1 then
         Room.Exits[4].ExitRoom := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('ExitD:', s) = 1 then
         Room.Exits[5].ExitRoom := StrToInt(ExtractWord(2, s, [' ', #9]))
        else if Pos('Triggers:', s) = 1 then
        begin
          i := StrToInt(ExtractWord(2, s, [' ', #9]));
          Room.Triggers.Add(TObject(i));
        end
        else if Pos('Mobs:', s) = 1 then
        begin
          RoomMob := TRoomMob.Create(StrToInt(ExtractWord(2, s, [' ', #9])));
          RoomMob.IFFlag := False;
          RoomMob.MaxQty := StrToInt(ExtractWord(3, s, [' ', #9]));
          Room.Mobs.Add(RoomMob);
        end
        else if Pos('Objects:', s) = 1 then
        begin
          RoomObj := TRoomObj.Create(StrToInt(ExtractWord(2, s, [' ', #9])));
          RoomObj.IFFlag := False;
          Room.Objects.Add(RoomObj);
        end
        else if Pos('DelObjects:', s) = 1 then
        begin
          i := StrToInt(ExtractWord(2, s, [' ', #9]));
          Room.DelObjects.Add(TObject(i));
        end;
      end;
      FileCounter := -2;
    finally
      CloseFile(f);
    end;
  except
    MessageDlg('    '#13#10': ' + FileName +
                 FileErrMsg(FileCounter), mtError, [mbOk], 0);
  end;
end;

destructor TRoomTemplet.Destroy;
var
  i: integer;
begin
  for i := 0 to Count-1 do
   TRoom(Objects[i]).Free;
  inherited Destroy;
end;

end.
