unit trigger;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, ExtCtrls;

type
  TTriggerForm = class(TForm)
    Label1: TLabel;
    TriggerListBox: TListBox;
    OkBtn: TButton;
    TriggerEdit: TSpinEdit;
    AddBtn: TButton;
    CancelBtn: TButton;
    Bevel1: TBevel;
    procedure FormActivate(Sender: TObject);
    procedure AddBtnClick(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure OkBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    Execute: boolean;
    procedure FillTriggerList(_model: byte);
    procedure SetTrigger(Trigger: integer);
    procedure GetTrigger(var Trigger: integer);
  end;

var
  TriggerForm: TTriggerForm;

implementation

{$R *.DFM}

uses
  vars;

procedure TTriggerForm.FormActivate(Sender: TObject);
begin
  Execute := False;
end;

procedure TTriggerForm.FillTriggerList(_model: byte);
var
  i, j: integer;
begin
  TriggerListBox.Clear;
  with TriggerList do
   for i := 0 to Count-1 do
    if TTrigger(Items[i]).Model = _model then
  begin
    j := TTrigger(Items[i]).Number;
    TriggerListBox.Items.AddObject(NumToName(j), TObject(j));
  end;
end;

procedure TTriggerForm.AddBtnClick(Sender: TObject);
begin
  if TriggerEdit.Value <> 0 then
  begin
    Execute := True;
    Close;
  end else
   MessageDlg(' ', mtError, [mbOk], 0);
end;

procedure TTriggerForm.CancelBtnClick(Sender: TObject);
begin
  Close;
end;

procedure TTriggerForm.OkBtnClick(Sender: TObject);
begin
  if TriggerListBox.ItemIndex >= 0 then
   TriggerEdit.Value := integer(TriggerListBox.Items.Objects[TriggerListBox.ItemIndex])
  else
   MessageDlg(' ', mtError, [mbOk], 0);
end;

procedure TTriggerForm.SetTrigger(Trigger: integer);
begin
  TriggerListBox.ItemIndex := TriggerListBox.Items.IndexOfObject(TObject(Trigger));
  TriggerEdit.Value := Trigger;
end;

procedure TTriggerForm.GetTrigger(var Trigger: integer);
begin
  Trigger := TriggerEdit.Value;
end;

end.
