unit zones;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin;

type
  TZoneForm = class(TForm)
    ListBox1: TListBox;
    Label1: TLabel;
    SpinEdit1: TSpinEdit;
    SelectBtn: TButton;
    NewBtn: TButton;
    procedure FormCreate(Sender: TObject);
    procedure SelectBtnClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure NewBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ZoneForm: TZoneForm;

implementation

{$R *.DFM}

uses
  vars;

procedure TZoneForm.FormCreate(Sender: TObject);
var
  SearchRec: TSearchRec;
  i: integer;
  Path: string;
begin
  ZoneList.Clear;
  Path := GetCurrentDir + '\MZONE\ZON\';
  i := FindFirst(Path + '*.zon', faReadOnly + faArchive, SearchRec);
  while i = 0 do
  begin
    ZoneList.LoadFromFile(Path + SearchRec.Name);
    i := FindNext(SearchRec);
  end;
  FindClose(SearchRec);
  ListBox1.Clear;
  for i := 0 to ZoneList.Count-1 do
   with TZone(ZoneList.Items[i]) do
    ListBox1.Items.AddObject(IntToStr(Number) + '  ' + Name, TObject(Number));
  CurrentZone := -1;
end;

procedure TZoneForm.SelectBtnClick(Sender: TObject);
begin
  if ListBox1.ItemIndex >= 0 then
  begin
    CurrentZone := ListBox1.ItemIndex;
  end;
  Close;
end;

procedure TZoneForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if CurrentZone = -1 then
  begin
    MessageDlg('  ', mtError, [mbOk], 0);
    CanClose := False;
  end else
   CanClose := True;
end;

procedure TZoneForm.NewBtnClick(Sender: TObject);
begin
  if ListBox1.Items.IndexOfObject(TObject(SpinEdit1.Value)) < 0 then
  begin
    CurrentZone := SpinEdit1.Value;
    Close;
  end else
   MessageDlg('     ', mtError, [mbOk], 0);
end;

end.
